---
title: contributing
subtitle: how to help out
author: cark
date: 2021-03-05
---
this wiki is written with markdown and turned into html with pandoc. i store everything on my phabricator instance @ https://code.cark.website/. if you're not familiar with phabricator already, the workflow may seem a little bit strange but this doc will try to guide you through it. if you're stuck, don't hesitate to send a message on irc!

0. make an account on the [phabricator instance ](https://code.cark.website/)  
   signups require approval beforehand to reduce spam, just ping an admin on irc and they'll approve it.

1. clone the repo from phabricator:
```bash
cark@southlondon:~$ git clone https://code.cark.website/diffusion/4/south-london.git
Cloning into 'south-london'...
remote: Enumerating objects: 111, done.
remote: Counting objects: 100% (111/111), done.
remote: Compressing objects: 100% (99/99), done.
remote: Total 111 (delta 51), reused 0 (delta 0), pack-reused 0
Receiving objects: 100% (111/111), 251.23 KiB | 2.03 MiB/s, done.
Resolving deltas: 100% (51/51), done.
```

2. make your changes  
   if you've never used markdown, you might want to have a look at [this here cheat sheet](https://www.markdownguide.org/cheat-sheet/)

3. build it  
   run `make` to build all wiki pages, you can then open up a http server and browse away!
```bash
cark@southlondon:~/south-london/wiki$ make
building contribute.html
$ python3 -m http.server 8000
Serving HTTP on 0.0.0.0 port 8000 (http://0.0.0.0:8000/) ...
# wiki content will be served up at http://localhost:8000/wiki/
```
4. commit and submit a diff to phabricator  
```bash
cark@southlondon:~/south-london/wiki$ git diff > patch.diff
# upload the file it spits out to https://code.cark.website/differential/diff/create/

# you can also use arc for this if you have it installed
cark@southlondon:~/south-london/wiki$ arc diff
You have uncommitted changes in this working copy.

  Working copy: /home/cark/south-london/

  Unstaged changes in working copy:
    changes.diff

Uncommitted changes in working copy:
    site/fonts/ComicMono-Bold.ttf
    site/fonts/ComicMono.ttf
    site/main.css
    site/wiki/contribute.md


    Do you want to create a new commit with these 5 change(s)? [y/N] y
# fill in the blanks when asked

```
5. fill in the details  
   give it a name, describe your changes, add a test plan (usually just run make and open in an http server). set south london as the tag.
after you've submitted it, you can ping an admin on irc or just wait for someone to see it and they'll review it. keep an eye on the comments in case changes are needed.